diff --git a/src/mongo/client/parallel.cpp b/src/mongo/client/parallel.cpp
index a2461ed..f13aea4 100644
--- a/src/mongo/client/parallel.cpp
+++ b/src/mongo/client/parallel.cpp
@@ -773,10 +773,10 @@ namespace mongo {
         ChunkManagerPtr manager;
         ShardPtr primary;
 
-        string prefix;
-        if( _totalTries > 0 ) prefix = str::stream() << "retrying (" << _totalTries << " tries)";
-        else prefix = "creating";
-        log( pc ) << prefix << " pcursor over " << _qSpec << " and " << _cInfo << endl;
+        // string prefix;
+        // if( _totalTries > 0 ) prefix = str::stream() << "retrying (" << _totalTries << " tries)";
+        // else prefix = "creating";
+        // log( pc ) << prefix << " pcursor over " << _qSpec << " and " << _cInfo << endl;
 
         set<Shard> todoStorage;
         set<Shard>& todo = todoStorage;
@@ -790,8 +790,8 @@ namespace mongo {
             // Try to get either the chunk manager or the primary shard
             config->getChunkManagerOrPrimary( ns, manager, primary );
 
-            if( manager ) vinfo = ( str::stream() << "[" << manager->getns() << " @ " << manager->getVersion().toString() << "]" );
-            else vinfo = (str::stream() << "[unsharded @ " << primary->toString() << "]" );
+            // if( manager ) vinfo = ( str::stream() << "[" << manager->getns() << " @ " << manager->getVersion().toString() << "]" );
+            // else vinfo = (str::stream() << "[unsharded @ " << primary->toString() << "]" );
 
             if( manager ) manager->getShardsForQuery( todo, specialFilter ? _cInfo.cmdFilter : _qSpec.filter() );
             else if( primary ) todo.insert( *primary );
@@ -799,7 +799,7 @@ namespace mongo {
             // Close all cursors on extra shards first, as these will be invalid
             for( map< Shard, PCMData >::iterator i = _cursorMap.begin(), end = _cursorMap.end(); i != end; ++i ){
 
-                log( pc ) << "closing cursor on shard " << i->first << " as the connection is no longer required by " << vinfo << endl;
+                // log( pc ) << "closing cursor on shard " << i->first << " as the connection is no longer required by " << vinfo << endl;
 
                 // Force total cleanup of these connections
                 if( todo.find( i->first ) == todo.end() ) i->second.cleanup();
@@ -809,13 +809,13 @@ namespace mongo {
 
             // Don't use version to get shards here
             todo = _qShards;
-            vinfo = str::stream() << "[" << _qShards.size() << " shards specified]";
+            // vinfo = str::stream() << "[" << _qShards.size() << " shards specified]";
 
         }
 
         verify( todo.size() );
 
-        log( pc ) << "initializing over " << todo.size() << " shards required by " << vinfo << endl;
+        // log( pc ) << "initializing over " << todo.size() << " shards required by " << vinfo << endl;
 
         // Don't retry indefinitely for whatever reason
         _totalTries++;
@@ -951,7 +951,7 @@ namespace mongo {
                 }
 
 
-                log( pc ) << "initialized " << ( isCommand() ? "command " : "query " ) << ( lazyInit ? "(lazily) " : "(full) " ) << "on shard " << shard << ", current connection state is " << mdata.toBSON() << endl;
+                // log( pc ) << "initialized " << ( isCommand() ? "command " : "query " ) << ( lazyInit ? "(lazily) " : "(full) " ) << "on shard " << shard << ", current connection state is " << mdata.toBSON() << endl;
 
             }
             catch( StaleConfigException& e ){
@@ -1042,14 +1042,14 @@ namespace mongo {
         bool retry = false;
         map< string, StaleConfigException > staleNSExceptions;
 
-        log( pc ) << "finishing over " << _cursorMap.size() << " shards" << endl;
+        // log( pc ) << "finishing over " << _cursorMap.size() << " shards" << endl;
 
         for( map< Shard, PCMData >::iterator i = _cursorMap.begin(), end = _cursorMap.end(); i != end; ++i ){
 
             const Shard& shard = i->first;
             PCMData& mdata = i->second;
 
-            log( pc ) << "finishing on shard " << shard << ", current connection state is " << mdata.toBSON() << endl;
+            // log( pc ) << "finishing on shard " << shard << ", current connection state is " << mdata.toBSON() << endl;
 
             // Ignore empty conns for now
             if( ! mdata.pcState ) continue;
@@ -1100,7 +1100,7 @@ namespace mongo {
                     // Finalize state
                     state->cursor->attach( state->conn.get() ); // Closes connection for us
 
-                    log( pc ) << "finished on shard " << shard << ", current connection state is " << mdata.toBSON() << endl;
+                    // log( pc ) << "finished on shard " << shard << ", current connection state is " << mdata.toBSON() << endl;
                 }
             }
             catch( RecvStaleConfigException& e ){