diff --git a/src/btree/bt_delete.c b/src/btree/bt_delete.c
index 54b7fed..6280e5a 100644
--- a/src/btree/bt_delete.c
+++ b/src/btree/bt_delete.c
@@ -76,6 +76,7 @@ __wt_delete_page(WT_SESSION_IMPL *session, WT_REF *ref, bool *skipp)
 			return (0);
 		}
 
+		__wt_errx(session, "DEL_PG: locked ref %p addr %p", ref, ref->addr);
 		(void)__wt_atomic_addv32(&S2BT(session)->evict_busy, 1);
 		ret = __wt_evict(session, ref, false);
 		(void)__wt_atomic_subv32(&S2BT(session)->evict_busy, 1);
@@ -96,6 +97,7 @@ __wt_delete_page(WT_SESSION_IMPL *session, WT_REF *ref, bool *skipp)
 	    !__wt_atomic_casv32(&ref->state, WT_REF_DISK, WT_REF_LOCKED))
 		return (0);
 
+	__wt_errx(session, "DEL_PG: 2 locked ref %p addr %p", ref, ref->addr);
 	/*
 	 * We cannot fast-delete pages that have overflow key/value items as
 	 * the overflow blocks have to be discarded.  The way we figure that
@@ -241,6 +243,7 @@ __wt_delete_page_skip(WT_SESSION_IMPL *session, WT_REF *ref, bool visible_all)
 	if (!__wt_atomic_casv32(&ref->state, WT_REF_DELETED, WT_REF_LOCKED))
 		return (false);
 
+	__wt_errx(session, "DEL_PG_SKIP: locked ref %p addr %p", ref, ref->addr);
 	skip = ref->page_del == NULL || (visible_all ?
 	    __wt_txn_visible_all(session, ref->page_del->txnid) :
 	    __wt_txn_visible(session, ref->page_del->txnid));
diff --git a/src/btree/bt_split.c b/src/btree/bt_split.c
index 7a05a88..dae6806 100644
--- a/src/btree/bt_split.c
+++ b/src/btree/bt_split.c
@@ -372,6 +372,7 @@ __split_ref_move(WT_SESSION_IMPL *session, WT_PAGE *from_home,
 		WT_ILLEGAL_VALUE(session);
 		}
 		ref->addr = addr;
+		__wt_errx(session, "REF_MOVE: ref %p addr %p", ref, addr);
 	}
 
 	/* And finally, copy the WT_REF pointer itself. */
@@ -1670,6 +1671,7 @@ __wt_multi_to_ref(WT_SESSION_IMPL *session,
 		 */
 		WT_RET(__wt_calloc_one(session, &addr));
 		ref->addr = addr;
+		__wt_errx(session, "MULTI_TO_REF: ref %p addr %p", ref, addr);
 		addr->size = multi->addr.size;
 		addr->type = multi->addr.type;
 		WT_RET(__wt_strndup(session,
@@ -1751,6 +1753,7 @@ __split_insert(WT_SESSION_IMPL *session, WT_REF *ref)
 	child->pindex_hint = ref->pindex_hint;
 	child->state = WT_REF_MEM;
 	child->addr = ref->addr;
+	__wt_errx(session, "SPLIT_INSERT: child %p ref %p addr %p", child, ref, ref->addr);
 
 	/*
 	 * The address has moved to the replacement WT_REF.  Make sure it isn't
@@ -2007,6 +2010,7 @@ err:	if (split_ref[0] != NULL) {
 		 * The address was moved to the replacement WT_REF, restore it.
 		 */
 		ref->addr = split_ref[0]->addr;
+		__wt_errx(session, "SPLIT_INSERT: ref %p addr %p", ref, ref->addr);
 
 		if (type == WT_PAGE_ROW_LEAF)
 			__wt_free(session, split_ref[0]->ref_ikey);
diff --git a/src/evict/evict_lru.c b/src/evict/evict_lru.c
index 9508c86..6659460 100644
--- a/src/evict/evict_lru.c
+++ b/src/evict/evict_lru.c
@@ -1559,6 +1559,8 @@ __evict_get_ref(
 			__evict_list_clear(session, evict);
 			continue;
 		}
+		__wt_errx(session, "GET_REF: locked ref %p addr %p",
+		    evict->ref, evict->ref->addr);
 
 		/*
 		 * Increment the busy count in the btree handle to prevent it
diff --git a/src/evict/evict_page.c b/src/evict/evict_page.c
index 2d20f53..3096fca 100644
--- a/src/evict/evict_page.c
+++ b/src/evict/evict_page.c
@@ -315,6 +315,7 @@ __evict_page_dirty_update(WT_SESSION_IMPL *session, WT_REF *ref, bool closing)
 		__wt_ref_out(session, ref);
 		ref->addr = addr;
 		WT_PUBLISH(ref->state, WT_REF_DISK);
+		__wt_errx(session, "EVICT_DIRTY: ref %p addr %p", ref, addr);
 		break;
 	WT_ILLEGAL_VALUE(session);
 	}
diff --git a/src/include/btree.i b/src/include/btree.i
index e0102a1..dd72ea0 100644
--- a/src/include/btree.i
+++ b/src/include/btree.i
@@ -1207,7 +1207,7 @@ __wt_page_release_evict(WT_SESSION_IMPL *session, WT_REF *ref)
 			ref->state = WT_REF_MEM;
 		return (ret == 0 ? EBUSY : ret);
 	}
-
+	__wt_errx(session, "PG_REL: locked ref %p addr %p", ref, ref->addr);
 	(void)__wt_atomic_addv32(&btree->evict_busy, 1);
 
 	too_big = page->memory_footprint > btree->maxmempage;
diff --git a/src/os_common/os_abort.c b/src/os_common/os_abort.c
index 034eedc..50f9dac 100644
--- a/src/os_common/os_abort.c
+++ b/src/os_common/os_abort.c
@@ -18,9 +18,11 @@ __wt_abort(WT_SESSION_IMPL *session)
 {
 	__wt_errx(session, "aborting WiredTiger library");
 
+#if 0
 #ifdef HAVE_DIAGNOSTIC
 	__wt_attach(session);
 #endif
+#endif
 
 	abort();
 	/* NOTREACHED */
diff --git a/src/reconcile/rec_write.c b/src/reconcile/rec_write.c
index b49946b..88d1a54 100644
--- a/src/reconcile/rec_write.c
+++ b/src/reconcile/rec_write.c
@@ -1483,6 +1483,9 @@ __rec_child_modify(WT_SESSION_IMPL *session,
 			if (!__wt_atomic_casv32(
 			    &ref->state, WT_REF_DELETED, WT_REF_LOCKED))
 				break;
+			__wt_errx(session,
+			    "REC_CHILD: deleted locked ref %p addr %p",
+			    ref, ref->addr);
 			ret = __rec_child_deleted(session, r, ref, statep);
 			WT_PUBLISH(ref->state, WT_REF_DELETED);
 			goto done;