diff --git a/etc/evergreen.yml b/etc/evergreen.yml
index 69a079d..656554a 100644
--- a/etc/evergreen.yml
+++ b/etc/evergreen.yml
@@ -134,6 +134,7 @@ variables:
   - ubuntu1604-arm64
   - ubuntu1404-jepsen
   - ubuntu1404-rocksdb
+  - ubuntu1404-rocksdb-asan
   - debian71
   - debian81
   - solaris-64-bit
@@ -325,7 +326,7 @@ functions:
         rm -rf rocksdb
         git clone https://github.com/facebook/rocksdb.git
         cd rocksdb
-        make CC=/opt/mongodbtoolchain/v2/bin/gcc CXX=/opt/mongodbtoolchain/v2/bin/g++ static_lib
+        make ${compile_flags_rocskdb} static_lib
         fi
 
   "build new tools" :
@@ -406,7 +407,7 @@ functions:
           # Set the shell process (and its children processes) to dump ELF headers (bit 4),
           # anonymous shared mappings (bit 1), and anonymous private mappings (bit 0).
           echo 0x13 > /proc/self/coredump_filter
-        
+
           if [ -f /sbin/sysctl ]; then
             # Check that the core pattern is set explicitly on our distro image instead
             # of being the OS's default value. This ensures that coredump names are consistent
@@ -7955,7 +7956,8 @@ buildvariants:
   - name: unittests
   - name: views
 
-- name: ubuntu1404-rocksdb
+- &rocksdb_variant
+  name: ubuntu1404-rocksdb
   display_name: Ubuntu 14.04 (RocksDB)
   modules:
   - rocksdb
@@ -7964,6 +7966,7 @@ buildvariants:
   batchtime: 1440 # 1 day
   expansions:
     build_rocksdb: true
+    compile_flags_rocksdb: CC=/opt/mongodbtoolchain/v2/bin/gcc CXX=/opt/mongodbtoolchain/v2/bin/g++
     compile_flags: -j$(grep -c ^processor /proc/cpuinfo) --dbg=off --opt=on CPPPATH=$(readlink -f ../rocksdb/include/) LIBPATH=$(readlink -f ../rocksdb/) LIBS=rocksdb CC=/opt/mongodbtoolchain/v2/bin/gcc CXX=/opt/mongodbtoolchain/v2/bin/g++ OBJCOPY=/opt/mongodbtoolchain/v2/bin/objcopy VARIANT_DIR=release --runtime-hardening=off
     num_jobs_available: $(grep -c ^processor /proc/cpuinfo)
     test_flags: --storageEngine=rocksdb
@@ -8025,6 +8028,76 @@ buildvariants:
   - name: unittests
   - name: views
 
+- <<: *rocksdb_variant
+  name: ubuntu1604-rocksdb-asan
+  display_name: ~ ASAN Ubuntu 16.04 (RocksDB)
+  run_on:
+  - ubuntu1604-build
+  expansions:
+    build_rocksdb: true
+    compile_flags_rocksdb: COMPILE_WITH_ASAN=1 CC=/opt/mongodbtoolchain/v2/bin/gcc CXX=/opt/mongodbtoolchain/v2/bin/g++
+    # We need llvm-symbolizer in the PATH for ASAN for clang-3.7 or later.
+    variant_path_suffix: /usr/lib/llvm-3.8/bin
+    san_options: LSAN_OPTIONS="suppressions=etc/lsan.suppressions" ASAN_OPTIONS=detect_leaks=1
+    compile_flags: CPPPATH=$(readlink -f ../rocksdb/include/) LIBPATH=$(readlink -f ../rocksdb/) LIBS=rocksdb CC=/opt/mongodbtoolchain/v2/bin/gcc CXX=/opt/mongodbtoolchain/v2/bin/g++ --dbg=on --opt=on --allocator=system --sanitize=address -j$(grep -c ^processor /proc/cpuinfo) --nostrip VARIANT_DIR=build --runtime-hardening=off
+    num_jobs_available: $(($(grep -c ^processor /proc/cpuinfo) / 3)) # Avoid starting too many mongod's under ASAN build.
+    test_flags: --storageEngine=rocksdb
+  tasks:
+  - name: compile
+    distros:
+    - ubuntu1604-build
+  - name: aggregation
+  - name: aggregation_WT
+  - name: aggregation_auth
+  - name: auth
+  - name: dbtest
+  # - name: disk
+  # - name: durability
+  # - name: dur_jscore_passthrough
+  - name: failpoints
+  - name: failpoints_auth
+  - name: gle_auth
+  - name: gle_auth_write_cmd
+  - name: gle_auth_basics_passthrough
+  - name: gle_auth_basics_passthrough_write_cmd
+  - name: sharding_gle_auth_basics_passthrough
+  - name: sharding_gle_auth_basics_passthrough_write_cmd
+  - name: jsCore
+  - name: jsCore_auth
+  - name: jsCore_compatibility
+  - name: jsCore_small_oplog
+  - name: jsCore_small_oplog_rs
+  - name: jstestfuzz
+  - name: jstestfuzz_concurrent_WT
+  - name: jstestfuzz_concurrent_replication_WT
+  - name: jstestfuzz_concurrent_sharded_WT
+  - name: jstestfuzz_replication
+  - name: jstestfuzz_sharded
+  - name: noPassthrough
+  - name: noPassthroughWithMongod
+  - name: bulk_gle_passthrough
+  - name: parallel
+  - name: parallel_compatibility
+  - name: concurrency
+  - name: concurrency_replication
+  - name: concurrency_sharded
+    # We use machines with more RAM to avoid OOM issues when validating collections.
+    distros:
+    - ubuntu1604-build
+  - name: concurrency_simultaneous
+  - name: replicasets
+  - name: replicasets_auth
+  - name: replication
+  - name: replication_WT
+  - name: replication_auth
+  - name: sharding
+  - name: sharding_auth
+  - name: slow1
+  - name: serial_run
+  - name: sharding_jscore_passthrough
+  - name: unittests
+  - name: views
+
 ###########################################
 #     Experimental buildvariants          #
 ###########################################